/*
 * IParkdeck.java
 */

/**
 * Schnittstelle fuer ein Parkhaus.
 */
public interface IParkdeck {
    
    /**
     * Ein Auto faehrt in das Parkhaus.
     * 
     * @param c einfahrendes Fahrzeug.
     */
    public void letIn(Car c);

    /**
     * Ein Auto verlaesst das Parkhaus.
     * 
     * @param c ausfahrendes Fahrzeug.
     */
    public void letOut(Car c);

    /**
     * Ermittelt die Anzahl der freien Plaetze.
     * 
     * @return Anzahl freier Plaetze.
     */
    public int getCapacity();

}
