/*
 * Mutex.cpp
 */
#include "MutexCounter.h"

MutexCounter::MutexCounter()
{
    count = 0;
    pthread_mutex_init(&lock, 0);
}

void MutexCounter::increment() {
    pthread_mutex_lock(&lock);
    count = count + 1;
    pthread_mutex_unlock(&lock);
}

int MutexCounter::getCount() const {
    return count;
}

MutexCounter::~MutexCounter() {
    pthread_mutex_destroy(&lock);
}
